#include <bits/stdc++.h>

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

#define out(x) #x << " = " << x << "  "

const int MAX_N = 1e6;
const int mod = 1e9 + 7;

typedef long long ll;
#define int ll

using namespace std;

int fen[MAX_N];

void fenUpdate( int x, int val ){
    while( x < MAX_N ){
        fen[x] += val;
        x += x & -x;
    }
}

int fenQuery( int x ){
    int nas = 0;
    while( x ){
        nas += fen[x];
        x -= x & -x;
    }
    return nas;
}

struct Node{
    int sumEven;
    int sumOdd;
    int numDividers;
    bool ending;
    int maxSuff;
    int maxPreff;

    Node( ){
        sumEven = sumOdd = 0;
        maxPreff = maxSuff = 0;
        ending = 0;
        numDividers = 0;
    }
}tree[4 * MAX_N];

int a[MAX_N];
bool divider[MAX_N];

Node combine( const Node& left, const Node& right ){
    Node nas = Node();

    cerr << out( left.ending ) << endl;
    if( left.ending ){

        if( left.numDividers & 1 ){

            nas.sumEven = left.sumEven + right.sumOdd;
            nas.sumOdd = left.sumOdd + right.sumEven;

        }else{

            nas.sumEven = left.sumEven + right.sumEven;
            nas.sumOdd = left.sumOdd + right.sumOdd;

        }

        nas.maxPreff = left.maxPreff;
        nas.maxSuff = right.maxSuff;
        nas.ending = right.ending;

        nas.numDividers = left.numDividers + right.numDividers;
    }else{

        if( left.numDividers & 1 ){

            nas.sumEven = left.sumEven + right.sumOdd;
            nas.sumOdd = left.sumOdd + right.sumEven - left.maxSuff - right.maxPreff + std::max( left.maxSuff, right.maxPreff );
        }else{

            nas.sumEven = left.sumEven + right.sumEven - left.maxSuff - right.maxPreff + std::max( left.maxSuff, right.maxPreff );
            nas.sumOdd = left.sumOdd + right.sumOdd;

        }

        nas.ending = right.ending;
        nas.numDividers = left.numDividers + right.numDividers;

        nas.maxPreff = left.maxPreff;
        if( !left.numDividers ) nas.maxPreff = std::max( nas.maxPreff, right.maxPreff );

        nas.maxSuff = right.maxSuff;
        if( !right.numDividers ) nas.maxSuff = std::max( nas.maxSuff, left.maxSuff );
    }

    return nas;
}

void update( int pos, int val, int l, int r, int x ){

    if( l == r ){
        cerr << out( l ) << out ( x ) << out( divider[l] ) << endl;
        a[l] += val;
        if( divider[l] ){
            tree[x].numDividers = 1;
            tree[x].ending = 1;
        }else {
            tree[x].numDividers = 0;
            tree[x].ending = 0;

        }

        tree[x].sumEven = a[l];
        tree[x].sumOdd = 0;

        tree[x].maxPreff = a[l];
        tree[x].maxSuff = 0;
        if( !divider[l] ) tree[x].maxSuff = a[l];

        return;
    }

    int m = ( l + r ) >> 1;
    if( pos <= m ) update( pos, val, l, m, 2*x );
    if( m+1 <= pos ) update( pos, val, m+1, r, 2*x + 1 );

    tree[x] = combine( tree[2*x] , tree[2*x + 1] );

    cerr << out( l ) << out( m )<< out( r ) << out( 2*x ) << out( 2*x + 1 ) << endl;
    cerr << out( tree[x].sumEven ) << out( tree[x].sumOdd ) << out( tree[x].numDividers ) << endl;
}

Node query( int lx, int rx, int l, int r, int x ){
    //cerr << out( lx ) << out( rx ) << out( l ) << out( r ) << out( x ) << endl;
    if( lx > r || l > rx ) return Node();

    if( lx <= l and r <= rx ) return tree[x];

    int m = ( l + r ) >> 1;
    Node left = query( lx, rx, l, m, 2*x );
    Node right = query( lx, rx, m+1, r, 2*x + 1 );

    return combine( left, right );
}

signed main (){

    #ifndef LOCAL
        std::ios_base::sync_with_stdio(false); std::cin.tie( NULL );
    #endif // LOCAL

    int n, q;
    std::cin >> n >> q;

    while( q-- ){

        int type;
        std::cin >> type;

        if( type == 1 ){
            int pos;
            std::cin >> pos;
            divider[pos] = true;
            fenUpdate( pos, 1 );
            update( pos, 0, 1, n, 1);
        }else if( type == 2 ){
            int pos;
            std::cin >> pos;
            divider[pos] = false;
            fenUpdate( pos, -1 );
            update( pos, 0, 1, n, 1);
        }else if( type == 3 ){
            int pos, val;
            std::cin >> pos >> val;

            update( pos, val, 1, n, 1 );
        }else{
            int l, r;
            std::cin >> l >> r;

            int numPrev = fenQuery( l-1 );
            Node nas = query( l, r, 1, n, 1 );

            cerr << out( numPrev ) << endl;
            cerr << " query " << l << " " << r << endl;
            cerr << out( nas.sumOdd ) << out( nas.sumEven ) << endl;
            if( numPrev & 1 ) std::cout << nas.sumEven << endl;
            else std::cout << nas.sumOdd << endl;

            //cerr << " query " << endl;
        }
    }

    return 0;
}
