#include<iostream>
#include<unordered_set>
#include<algorithm>
#include<vector>

using namespace std;
static const int MAXN=100;
static const int MEMORY=2*MAXN;
static const int MAX_CALLS=1e7;

static unsigned short int mem[MEMORY][MEMORY];

void output_message (string message="") {
    cout << message << endl ;
    exit(0);
}

static unordered_set <int> used;
static unordered_set <int> extra;
static int n;
unsigned short int get_mem (int x, int y) {
    if ((x<0)||(x>=2*n)||(y<0)||(y>=2*n)) output_message("Invalid index!");
    used.insert(x*MEMORY+y);
    return mem[x][y];
}
void set_mem (int x, int y, unsigned short int value) {
    if ((x<0)||(x>=2*n)||(y<0)||(y>=2*n)) output_message("Invalid index!");
    if ((x>=n)||(y>=n)) extra.insert(x*MEMORY+y);
    mem[x][y]=value;
}

#include "zeroes.h"
#include "zeroes.cpp"

extern bool solve (int n, int call);

static bool rows[MAXN],cols[MAXN];
static unsigned short int ans[MAXN][MAXN];
int main () {
    cin >> n ;
    for (int i=0; i<n; i++) {
        for (int j=0; j<n; j++) {
            cin >> mem[i][j] ;
            if (mem[i][j]==0) rows[i]=true, cols[j]=true;
        }
    }
    for (int i=0; i<n; i++) {
        for (int j=0; j<n; j++) {
            ans[i][j]=mem[i][j];
            if ((rows[i]==true)||(cols[j]==true)) ans[i][j]=0;
        }
    }
    static int max_gets=0;
    for (int call=0; ; call++) {
        if (call>=MAX_CALLS) output_message("Too many steps!");
        used.clear();
        auto res=solve(n,call);
        max_gets=max(max_gets,int(used.size()));
        if (res==true) break;
    }

    cout << endl ;
    for (int i=0; i<n; i++) {
        for (int j=0; j<n; j++) {
            cout << mem[i][j] << " ";
        }
        cout << endl ;
    }
    cout << endl ;
    for (int i=0; i<n; i++) {
        for (int j=0; j<n; j++) {
            if (mem[i][j]!=ans[i][j]) output_message("Incorrect matrix after finish!");
        }
    }
    cout << "Your solution used " << extra.size() << " extra memory.\n";
    cout << "Your solution maximum get calls was: " << max_gets << endl ;
    return 0;
}

