#include "zeroes.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>

const int INF  = 1e9;

int getMem(int idx, int n)
{
    return get_mem(n + idx / n, idx % n);
}

void setMem(int idx, int val, int n)
{
    set_mem(n + idx / n, idx % n, val);
}

bool solve(int N, int call)
{
    int n = N;
    if (n == 1)
    {
        return true;
    }

    if (call < 2 * n)
    {
        setMem(call, (1 << 16) - 1, n);
    } else if (call < 2 * n + n * n)
    {
        int cnt = call - 2 * n;
        int row = cnt / n;
        int col = cnt % n;
        int val = get_mem(row, col);
        int val1 = getMem(row, n);
        int val2 = getMem(col + n, n);
        if (val == 0) setMem(row, val1 & val, n);
        if (val == 0) setMem(col + n, val2 & val, n);
    } else if (call < 2 * n + 2 * n * n)
    {
        int cnt = call - 2 * n - n * n;
        int row = cnt / n;
        int col = cnt % n;
        int val = get_mem(row, col);
        int val1 = getMem(row, n);
        int val2 = getMem(n + col, n);
        if (val1 == 0 || val2 == 0)
        {
            set_mem(row, col, 0);
        }
    } else
    {
        return true;
    }

    return false;
}
