#include "zeroes.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>

const int INF  = 1e9;

int getMem(int idx, int n)
{
    assert(idx != n - 1 && idx < 2 * n);
    int val;
    if (idx < n - 1) val = get_mem(n, idx);
    else val = get_mem(n + 1, idx - n);
    return val;
}

void setMem(int idx, int val, int n)
{
    assert(idx != n - 1 && idx < 2 * n);
    if (idx < n - 1) set_mem(n, idx, val);
    else set_mem(n + 1, (idx - n), val);
}

bool solve(int N, int call)
{
    int n = N;
    if (n == 1)
    {
        return true;
    }

    if (call < 2 * n)
    {
        if (call != n - 1) setMem(call, 1, n);
        return false;
    }

    call -= 2 * n;
    if (call < n * n)
    {
        int cnt = call;
        int row = cnt / n;
        int col = cnt % n;
        int val = get_mem(row, col);
        if (row < n - 1 && val == 0) setMem(row, 0, n);
        if (val == 0) setMem(col + n, 0, n);
        return false;
    }

    call -= n * n;
    if (call < n * (n - 1))
    {
        int cnt = call;
        int row = cnt / n;
        int col = cnt % n;
        int val = get_mem(row, col);
        int val1 = getMem(row, n);
        int val2 = getMem(n + col, n);
        if (val1 == 0 || val2 == 0)
        {
            set_mem(row, col, 0);
        }

        return false;
    }

    call -= n * (n - 1);
    if (call == 0)
    {
        int val = get_mem(n - 1, call);
        if (val == 0) setMem(call, 0, n);
        else setMem(call, 1, n);
        return false;
    }

    if (call < n - 1)
    {
        int val = get_mem(n - 1, call);
        int val2 = getMem(call - 1, n);
        if (val2 == 0) val = 0;

        if (val == 0) setMem(call, 0, n);
        else setMem(call, 1, n);
        return false;
    }

    if (call == n - 1)
    {
        int val = get_mem(n - 1, call);
        int val2 = getMem(call - 1, n);
        if (val2 == 0) val = 0;

        if (val == 0) setMem(call - 1, 0, n);
        else setMem(call - 1, 1, n);
        return false;
    }

    call -= n;
    if (call < n)
    {
        int cnt = call;
        int row = n - 1;
        int col = cnt % n;
        int val = get_mem(row, col);
        int val1 = getMem(n - 2, n);
        int val2 = getMem(n + col, n);
        if (val1 == 0 || val2 == 0)
        {
            set_mem(row, col, 0);
        }

        return false;
    }

    return true;
}
