#include <iostream>
using namespace std;
#define endl '\n'
struct Node {
    int pref;
    int suf;
    int odd;
    int even;
    int cnt;
};
const int MAXN=1e5+10;
Node tree[MAXN];
bool d[MAXN];
void print_node(Node a) {
    cout << a.pref << ' ' << a.suf << ' ' << a.even << ' ' << a.odd << ' ' << a.cnt << endl;
}
Node merge_node (Node a, Node b, int mid) {
    if (a.cnt==-1) return b;
    if (b.cnt==-1) return a;
    //cout << "merge " << mid << ' ' << d[mid] << endl; print_node(a); print_node(b);
    Node ans;
    ans.cnt=a.cnt+b.cnt+d[mid];
    if (ans.cnt==0) {
        ans.suf=ans.pref=max(a.pref,b.pref);
        ans.even=ans.pref;
        ans.odd=0;
        //print_node(ans);
        return ans;
    }
    ans.pref=a.pref; ans.suf=b.suf;
    ans.odd=a.odd; ans.even=a.even;
    if (!d[mid]) {
        if (a.cnt==0) ans.pref=max(ans.pref,b.pref);
        if (b.cnt==0) ans.suf=max(ans.suf,a.suf);
        if (a.cnt%2==0) {
            ans.even-=a.suf+b.pref;
            ans.even+=max(a.suf,b.pref);
        } else {
            ans.odd-=a.suf+b.pref;
            ans.odd+=max(a.suf,b.pref);
        }
    }
    int cur=a.cnt+d[mid];
    if (cur%2==0) {
        ans.even+=b.even;
        ans.odd+=b.odd;
    } else {
        ans.even+=b.odd;
        ans.odd+=b.even;
    }
    //print_node(ans);
    return ans;
}
void update(int node, int l, int r, int qind, int ch) {
    if (qind>r || qind<l) return;
    if (l==r) {
        tree[node].even+=ch;
        tree[node].suf+=ch;
        tree[node].pref+=ch;
        return;
    }
    int mid=(l+r)/2;
    update(node*2,l,mid,qind,ch);
    update(node*2+1,mid+1,r,qind,ch);
    tree[node]=merge_node(tree[node*2],tree[node*2+1],mid);
}
Node query(int node, int l, int r, int ql, int qr) {
    if (ql>r || qr<l) return {-1,-1,-1,-1,-1};
    if (l>=ql && r<=qr) return tree[node];
    int mid=(l+r)/2;
    return merge_node(query(node*2,l,mid,ql,qr),query(node*2+1,mid+1,r,ql,qr),mid);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    int type, ind, ch, l, r;
    for (int i=0;i<q;i++) {
        cin >> type;
        if (type==1 || type==2) {
            cin >> ind;
            d[ind]=!d[ind];
            update(1,1,n,ind,0);
        } else if (type==3) {
            cin >> ind >> ch;
            update(1,1,n,ind,ch);
        } else {
            cin >> l >> r;
            Node ans=query(1,1,n,l,r);
            Node pref=query(1,1,n,1,l-1);
            if (pref.cnt==-1) pref.cnt=0;
            pref.cnt+=d[l-1];
            if (pref.cnt%2==0) cout << ans.odd << endl;
            else cout << ans.even << endl;
        }
    }
    return 0;
}

