#include<bits/stdc++.h>
#define pb push_back
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn=1e5+3;
const int mod=1e9+7;
const double EPS = 0.00001;

int n, q;
bool dividers[maxn];
int f[4*maxn];

void fen_upd(int x, int val){
    while(x<n){
        f[x]+=val;
        x += x & -x;
    }

    return;
}

ll fen_query(int x){
    ll sum=0;
    while(x){
        sum+=f[x];
        x -= x & -x;
    }

    return sum;
}

struct Node{
    int num_zones;
    int sum_even;
    int sum_odd;
    int max_pref;
    int max_suf;
    bool ending;

    Node(){
        num_zones = 0;
        sum_even=sum_odd=0;
        max_pref=max_suf=0;
        ending=false;
    }
} tree[4*maxn];

Node combine(Node& left, Node& right){
    Node nas;

    if(left.ending){
        nas.num_zones=left.num_zones+right.num_zones;

        if(left.num_zones & 1){
            nas.sum_even = left.sum_even + right.sum_odd;
            nas.sum_odd = left.sum_odd + right.sum_even;
        }else{
            nas.sum_even = left.sum_even + right.sum_even;
            nas.sum_odd = left.sum_odd + right.sum_odd;
        }
        nas.ending = right.ending;
        nas.max_pref = left.max_pref;
        nas.max_suf = right.max_suf;

    }else{

        nas.num_zones = left.num_zones + right.num_zones;
        if(left.num_zones & 1){
            nas.sum_even = left.sum_even + right.sum_odd;
            nas.sum_odd = left.sum_odd + right.sum_even - left.max_suf - right.max_pref + max(left.max_suf, right.max_pref);
        }else{
            nas.sum_odd = left.sum_odd +right.sum_odd;
            nas.sum_even = left.sum_even + right.sum_even - left.max_suf - right.max_pref + max(left.max_suf, right.max_pref);
        }

        nas.ending = right.ending;
        nas.max_pref = left.max_pref;
        if(left.num_zones == 0) nas.max_pref = max(nas.max_pref, right.max_pref);
        nas.max_suf = right.max_suf;
        if(right.num_zones == 0) nas.max_suf = max(nas.max_suf, left.max_suf);

    }

    return nas;
}

void update(int x, int l, int r, int pos, int val){
    if(l==r and l==pos){

        tree[x].num_zones=tree[x].ending=dividers[l];
        tree[x].sum_even+=val;
        tree[x].sum_odd=0;

        tree[x].max_pref+=val;
        tree[x].max_suf+=val;

        return ;
    }

    int m=(l+r)/2;
    if(pos<=m) update(x*2, l, m, pos, val);
    if(pos>m) update(x*2+1, m+1, r, pos, val);

    tree[x]=combine(tree[x*2], tree[x*2+1]);
}

Node query(int x, int l, int r, int ql, int qr){
    if(ql<=l and r<=qr) return tree[x];

    Node nas;
    nas.num_zones = -1;

    Node left, right;
    int m=(l+r)/2;
    if(ql<=m) left=query(x*2, l, m, ql, qr);
    if(qr>m) right=query(x*2+1, m+1, r, ql, qr);

    return combine(left, right);
}

int main(){

cin>>n>>q;

while(q--){
    int t;
    cin>>t;

    if(t==1){
        int pos;
        cin>>pos;
        dividers[pos]=true;
        fen_upd(pos, 1);
        update(1, 0, maxn-1, pos, 0);
    }
    if(t==2){
        int pos;
        cin>>pos;
        dividers[pos]=false;
        fen_upd(pos, -1);
        update(1, 0, maxn-1, pos, 0);
    }
    if(t==3){
        int pos, val;
        cin>>pos>>val;
        update(1, 0, maxn-1, pos, val);
    }
    if(t==4){
        int l, r;
        cin>>l>>r;

        int num_before = fen_query(l-1);

        Node nas = query(1, 0, maxn-1, l, r);
        if(num_before & 1){
            cout<<nas.sum_even<<endl;
        }else{
            cout<<nas.sum_odd<<endl;
        }
    }
}

return 0;
}

