#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int n, q;
vector<int> v;
bool divd[MAXN + 5];
long long tree[4 * MAXN + 5];
long long res[MAXN + 5], pref[MAXN + 5];

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = res[l];
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

long long query(int v, int l, int r, int ql, int qr)
{
    if (qr < l or r < ql) return 0;
    if (ql <= l and r <= qr) return tree[v];

    int mid = (l + r) / 2;
    return max(query(2 * v, l, mid, ql, qr), query(2 * v + 1, mid + 1, r, ql, qr));
}

void calc()
{
    v.push_back(1);
    int room = 0;
    long long mx = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (divd[i])
        {
            v.push_back(i);
            if (room) pref[room] = pref[room - 1] + mx;
            room++;
            mx = 0;
        }
        if (room % 2) mx = max(mx, res[i]);
    }
    pref[room] = pref[room - 1] + mx;
    v.push_back(n + 1);

    build(1, 1, n);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> q;

    bool flag = false;
    for (int i = 1; i <= q; ++ i)
    {
        int t;
        cin >> t;

        if (t == 1)
        {
            int p;
            cin >> p;
            divd[p + 1] = true;
        }
        else if (t == 2)
        {
            int p;
            cin >> p;
            divd[p + 1] = false;
        }
        else if (t == 3)
        {
            int c, a;
            cin >> c >> a;
            res[c] += a;
        }
        else
        {
            if (!flag)
            {
                calc();
                flag = true;
            }

            int l, r;
            cin >> l >> r;

            long long ans;
            int pl = lower_bound(v.begin(), v.end(), l) - v.begin();
            int pr = lower_bound(v.begin(), v.end(), r + 1) - v.begin() - 1;
            ans = pref[pr - 1] - (pl ? pref[pl - 1] : 0);
            if (l < v[pl] and pl % 2 == 0) ans += query(1, 1, n, l, v[pl] - 1);
            if (pr % 2 == 1) ans += query(1, 1, n, v[pr], r);
            cout << ans << endl;
        }
    }

    return 0;
}
