#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int tree[4 * MAXN + 5];
long long res[MAXN + 5];

void update(int v, int l, int r, int ul, int ur, int val)
{
    if (ur < l or r < ul) return;
    if (ul <= l and r <= ur)
    {
        tree[v] += val;
        return;
    }

    int mid = (l + r) / 2;
    update(2 * v, l, mid, ul, ur, val);
    update(2 * v + 1, mid + 1, r, ul, ur, val);
}

int query(int v, int l, int r, int p)
{
    if (l == r) return tree[v];

    int mid = (l + r) / 2;
    if (p <= mid) return (tree[v] + query(2 * v, l, mid, p));
    return (tree[v] + query(2 * v + 1, mid + 1, r, p));
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= q; ++ i)
    {
        int t;
        cin >> t;

        if (t == 1)
        {
            int p;
            cin >> p;
            update(1, 1, n, p + 1, n, +1);
        }
        else if (t == 2)
        {
            int p;
            cin >> p;
            update(1, 1, n, p + 1, n, -1);
        }
        else if (t == 3)
        {
            int c, a;
            cin >> c >> a;
            res[c] += a;
        }
        else
        {
            int l, r;
            cin >> l >> r;
            int q = query(1, 1, n, l);
            if (q % 2) cout << res[l] << endl;
            else cout << 0 << endl;
        }
    }

    return 0;
}
