#include <iostream>
#include <vector>
using namespace std;
#define ll long long

ll n, k, l;

int bin_search(const vector<ll>& v, ll x, bool searchHighEnd) {
    ll l = -1, r = v.size();
    while (l + 1 < r) {
        ll mid = (l + r) / 2;
        if (v[mid] == x) {
            return mid + searchHighEnd;
        }
        if (v[mid] <= x) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return r;
}

ll solve(const vector<ll>& pos, ll depth) {
    if (depth == 0) {
//        cout << "return " << n - pos.size() << "\n";
        return n - pos.size();
    }

    if (pos.size() == 1) {
        return n;
    }
    ll maxSol = 0;
    for (ll i = 0; i < pos.size(); i++) {
        ll rBRes = bin_search(pos, pos[i] + l, 1);
        ll lBRes = bin_search(pos, pos[i] - l, 0);
        ll dSR = pos[i] + l - pos[rBRes - 1];
        ll dSL = pos[lBRes] - (pos[i] - l);

//        cout << depth << "; " << i << "; " << lBRes << " " << rBRes << "; " << dSR << " " << dSL << " ";
        if ((i != 0 && pos[i] - pos[i - 1] <= dSR) || (i != pos.size() - 1 && pos[i + 1] - pos[i] <= dSL)) {
//            cout << "process killed\n";
            continue;
        }
        vector<ll> newVector;
        for (ll j = 0; j < pos.size(); j++) {
            if (j < lBRes || rBRes - 1 < j) {
                newVector.push_back(pos[j]);
            }
        }
//        cout << newVector.size() << "\n";
        maxSol = max(maxSol, solve(newVector, depth - 1));
    }
    return maxSol;
}

vector<ll> stPos;

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k >> l;
    stPos.push_back(0);

    for (ll i = 0; i < n - 1; i++) {
        ll temp;
        cin >> temp;
        stPos.push_back(stPos[stPos.size() - 1] + temp);
    }
    cout << solve(stPos, k);
}
