#include <iostream>
#include <vector>
#include <map>
using namespace std;
#define ll long long

ll n, k, l;

int bin_search(const vector<ll>& v, ll x, bool searchHighEnd) {
    ll l = -1, r = v.size();
    while (l + 1 < r) {
        ll mid = (l + r) / 2;
        if (v[mid] == x) {
            return mid + searchHighEnd;
        }
        if (v[mid] <= x) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return r;
}

ll solve(const vector<ll>& pos, ll depth, ll stIdx) {
    if (depth == 0 || stIdx >= pos.size()) {
        return n - pos.size();
    }

    if (pos.size() == 1) {
        return n;
    }
    ll maxSol = 0, maxRange = 0, maxRangeIdx = n;
    bool lastBroken = 0;
    map<ll, bool> found;
    vector<ll> check;
    for (ll i = stIdx; i < pos.size(); i++) {
        ll rBRes = bin_search(pos, pos[i] + l, 1);
        ll lBRes = bin_search(pos, pos[i] - l, 0);
        ll dsR = pos[i] + l - pos[rBRes - 1];
        ll dsL = pos[lBRes] - (pos[i] - l);

        if ((i != 0 && pos[i] - pos[i - 1] <= dsR & !lastBroken) || (i != pos.size() - 1 && pos[i + 1] - pos[i] <= dsL)) {
            lastBroken = 1;
            continue;
        }
        if (!found[rBRes - lBRes]) {
            check.push_back(i);
            found[rBRes - lBRes] = 1;
        }
        if (rBRes - lBRes > maxRange) {
            maxRange = rBRes - lBRes;
            maxRangeIdx = check.size() - 1;
        }
    }
    check.erase(check.begin() + maxRangeIdx + 1, check.end());
    check.erase(check.begin(), check.begin() + maxRangeIdx - 2);
    for (auto i : check) {
        ll rBRes = bin_search(pos, pos[i] + l, 1);
        ll lBRes = bin_search(pos, pos[i] - l, 0);
        vector<ll> newVector;
        ll newStIdx = n + 2;
        for (ll j = 0; j < pos.size(); j++) {
            if (j < lBRes || rBRes - 1 < j) {
                newVector.push_back(pos[j]);
            }
            if (rBRes - 1 < j && newStIdx == n + 2) {
                newStIdx = newVector.size() - 1;
            }
        }
        lastBroken = 0;

        maxSol = max(maxSol, solve(newVector, depth - 1, newStIdx));
    }
    return maxSol;
}

vector<ll> stPos;

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k >> l;
    stPos.push_back(0);

    for (ll i = 0; i < n - 1; i++) {
        ll temp;
        cin >> temp;
        stPos.push_back(stPos[stPos.size() - 1] + temp);
    }
    cout << solve(stPos, k, 0);
}
